"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = void 0;
// Inspiration: https://github.com/percy/cli/blob/43a608c1f49e0e65cc78e00a55a9506c45173da5/packages/cli-upload/src/commands/upload.js
// https://github.com/percy/cli/blob/43a608c1f49e0e65cc78e00a55a9506c45173da5/packages/cli-upload/src/resources.js
var client_1 = require("@percy/client");
var chalk = require("chalk");
var mime = require("mime");
var fs = require("fs");
var core_1 = require("@paperclip-ui/core");
var diff_utils_1 = require("@paperclip-ui/diff-utils");
var crypto_1 = require("crypto");
var pLimit = require("p-limit");
var EMPTY_CONTENT_STATE = "<html><head></head><body></body></html>";
// max size for frame
var MAX_FRAME_WIDTH = 2000;
var MAX_CONCURRENT = 10;
var run = function (sourceDirectory, options) {
    if (options === void 0) { options = {}; }
    return __awaiter(void 0, void 0, void 0, function () {
        var cwd, engine, client, buildId, limit;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    cwd = options.cwd;
                    return [4 /*yield*/, (0, core_1.createEngineDelegate)({
                            mode: core_1.EngineMode.MultiFrame
                        })];
                case 1:
                    engine = _a.sent();
                    client = new client_1.default({
                        token: process.env.PERCY_TOKEN
                    });
                    return [4 /*yield*/, client.createBuild()];
                case 2:
                    buildId = (_a.sent()).data.id;
                    limit = pLimit(MAX_CONCURRENT);
                    return [4 /*yield*/, (0, diff_utils_1.eachFrame)(sourceDirectory, options, function (_a) {
                            var html = _a.html, annotations = _a.annotations, snapshotName = _a.uniqueTitle, assetPaths = _a.assets;
                            return __awaiter(void 0, void 0, void 0, function () {
                                var resources;
                                return __generator(this, function (_b) {
                                    resources = __spreadArray([
                                        {
                                            url: "/",
                                            root: true,
                                            mimetype: "text/html",
                                            sha: (0, crypto_1.createHash)("sha256")
                                                .update(html, "utf-8")
                                                .digest("hex"),
                                            content: html
                                        }
                                    ], Object.keys(assetPaths)
                                        .map(function (filePath) {
                                        var url = assetPaths[filePath];
                                        var content = fs.readFileSync(filePath);
                                        var mimetype = mime.getType(filePath);
                                        return {
                                            url: url,
                                            sha: (0, crypto_1.createHash)("sha256")
                                                .update(fs.readFileSync(filePath))
                                                .digest("hex"),
                                            mimetype: mimetype,
                                            content: content
                                        };
                                    })
                                        .filter(Boolean), true);
                                    return [2 /*return*/, limit(function () { return __awaiter(void 0, void 0, void 0, function () {
                                            var e_1;
                                            var _a;
                                            return __generator(this, function (_b) {
                                                switch (_b.label) {
                                                    case 0:
                                                        console.info("snap ".concat(snapshotName));
                                                        _b.label = 1;
                                                    case 1:
                                                        _b.trys.push([1, 3, , 4]);
                                                        return [4 /*yield*/, client.sendSnapshot(buildId, {
                                                                name: snapshotName,
                                                                widths: ((_a = annotations.frame) === null || _a === void 0 ? void 0 : _a.width)
                                                                    ? [Math.min(annotations.frame.width, MAX_FRAME_WIDTH)]
                                                                    : null,
                                                                resources: resources
                                                            })];
                                                    case 2:
                                                        _b.sent();
                                                        return [3 /*break*/, 4];
                                                    case 3:
                                                        e_1 = _b.sent();
                                                        console.error(chalk.red(e_1.stack));
                                                        return [3 /*break*/, 4];
                                                    case 4: return [2 /*return*/];
                                                }
                                            });
                                        }); })];
                                });
                            });
                        })];
                case 3: return [4 /*yield*/, _a.sent()];
                case 4:
                    _a.sent();
                    console.info("Waiting for build to finalize...");
                    return [4 /*yield*/, client.finalizeBuild(buildId)];
                case 5:
                    _a.sent();
                    console.info("Done!");
                    return [2 /*return*/];
            }
        });
    });
};
exports.run = run;
